;:::::::::::::::::::::::::::::: rhvKrypt :::::::::::::::::::::::::::::::
; +++ single file encryption/decryption tool
; +++  Verlag Raphael Heinrich Berlin 2003-2006
; +++ rhvKrypt is freeware
; +++ comments: raphael.heinrich@heinrichverlag.de
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


      .486              
      .model flat, stdcall  
      option casemap :none  
      
; includes
      include f:\asm\masm\include\windows.inc
      include f:\asm\masm\include\masm32.inc
      include f:\asm\masm\include\user32.inc      
      include f:\asm\masm\include\kernel32.inc     

; libraries
      includelib f:\asm\masm\lib\masm32.lib      
      includelib f:\asm\masm\lib\user32.lib
      includelib f:\asm\masm\lib\kernel32.lib

; makros      
    RETURN MACRO arg
          mov eax, arg
          ret
    ENDM
    
    REQUIRE MACRO size, p_dest          
          invoke GetProcessHeap          
          invoke HeapAlloc, eax, HEAP_ZERO_MEMORY, size
          mov [p_dest], eax
    ENDM   
          
;Prototypes      
       Main      PROTO
       CheckCmd  PROTO
       LoadFile  PROTO :DWORD
       rhvKrypt  PROTO :DWORD, :DWORD, :DWORD, :DWORD
       SaveFile  PROTO :DWORD, :DWORD, :DWORD
       DoMsg     PROTO :DWORD, :DWORD

; Declarations
        RHVKRYPT_OPT_KEYVALUE   equ 1           ; Use commandline provided key for encryption/decryption       
        RHVKRYPT_OPT_KEYFILE    equ 2           ; Use contents of keyfile as binary key
        RHVKRYPT_OPT_SILENT     equ 4           ; Silent modus, no messages shown
        RHVKRYPT_OPT_COPY       equ 8           ; Create new destination file at provided location
        RHVKRYPT_OPT_MASMLIB    equ 16          ; Use masmlib XOrData

        
.data
        APP_TITLE db "rhvKrypt",0
        
        ERR_SUCCESS         db "Encryption/decryption successful.", 13, 13, "Time used for file input/output: %lu milliseconds", 13, "Time used for encryption/decryption: %lu milliseconds", 0    
        ERR_CMD_MISSING     db "File encryption/decryption tool", 13, " Verlag Raphael Heinrich Berlin 2003-2006", 13, 13, "Usage: rhvKrypt.exe [-k] [-f] [-s] [-c] [-m] source [destination] [key|keyfile]", 13, 13, "Switches described:", 13, 9,  "-k: use command line provided key string", 13, 9, "-f: use key file", 13, 9, "-s: silent modus", 13, 9, "-c: copy/create new file at different location" , 13, 9, "-m: use masmlib XOrData algorithm", 0
        ERR_FILE_MISSING    db "Invalid filename or unable to open source file", 0
        ERR_DEST_CREATE     db "Unable to create destination file", 0
        ERR_ALLOC           db "Insufficient memory", 0
        ERR_FILE_READ       db "Unable to read file data", 0
        ERR_DEST_WRITE      db "Unable to write destination data", 0
        ERR_FILE_SIZE       db "The specified file is too large for processing", 0
        ERR_CMD_ORDER       db "Invalid command: incorrect order of arguments", 0
        ERR_CMD_FLAG        db "Invalid command: unknown command flag", 0
        ERR_CMD_QUOT        db "Invalid command: no matching quotation marks", 0
        ERR_CMD_SOURCE      db "Invalid command: source file expected", 0
        ERR_CMD_ARGS        db "Invalid command: too much arguments", 0
        ERR_CMD_EMPTY       db "Invalid command: empty path/key string value", 0
        ERR_FILE_EMPTY      db "Zero size file", 0
        ERR_DEST_FULL       db "Unable to write full destination data", 0
        ERR_CMD_DEST        db "Invalid command: copy flag set, destination file expected", 0
        ERR_CMD_KEY         db "Invalid command: one of key flags set, key/keyfile value expected", 0
        ERR_KEY_MISSING     db "Invalid filename or unable to open key file", 0
        ERR_FILE_WRITABLE   db "File write error. The source file has readonly attributes or is used by another program.", 0

        TIME_1 dd 0
        TIME_2 dd 0
        TIME_3 dd 0
        TIME_4 dd 0

        k_flags dd 0
        k_lend dd 0
        k_lenk dd 0
        
        p_source dd 0
        p_dest dd 0        
        p_key dd 0
        p_keyval dd 0
        p_data dd 0

.data?
        ;h_inst dd ?                                   


              
.code
start:      
      invoke Main
      invoke ExitProcess, eax


;####################### Main ########################
Main proc
      LOCAL h_hp :DWORD
      LOCAL p_ret :DWORD      
      mov p_ret, 0   
               
      ; process command line
      invoke CheckCmd
      .IF eax 
            mov p_ret, eax
            jmp LINEExit
      .ENDIF

     


      ; set counter
	invoke GetTickCount
	mov TIME_1, eax

      ; read source file data
      invoke LoadFile, p_source
      .IF eax 
            mov p_ret, eax
            jmp LINEExit
      .ELSE
            mov p_data, ecx
            mov k_lend, edx
      .ENDIF
      
      ; update key values
      .IF k_flags & RHVKRYPT_OPT_KEYFILE
            invoke LoadFile, p_key
            .IF eax 
                mov p_ret, eax
                .IF eax==2
                    mov p_ret, 18
                .ENDIF
                jmp LINEExit
            .ELSE
                mov p_keyval, ecx
                mov k_lenk, edx
            .ENDIF
      .ELSE
            .IF k_flags & RHVKRYPT_OPT_KEYVALUE 
                push p_key           
                pop p_keyval
            .ELSE
                lea eax, APP_TITLE
                mov p_keyval, eax             
            .ENDIF
            invoke lstrlen, p_keyval
            mov k_lenk, eax
      .ENDIF
      
      ; set counter
      invoke GetTickCount
    	mov TIME_2, eax

      ; krypt the data
      .IF (k_flags & RHVKRYPT_OPT_MASMLIB)
            ; to demonstrate, that we are not about to reinvent a bicycle, 
            ; we implement also the masm-lib provided basic krypt algorithm
            invoke XorData, p_data, k_lend, p_keyval, k_lenk
      .ELSE
            invoke rhvKrypt, p_data, p_keyval, k_lend, k_lenk
      .ENDIF 
        
      ; set counter
      invoke GetTickCount
    	mov TIME_3, eax

      ; write destination file data
      invoke SaveFile, p_dest, p_data, k_lend
      .IF eax 
            mov p_ret, eax
      .ENDIF

      ; set counter 
      invoke GetTickCount
    	mov TIME_4, eax
          
LINEExit:
      ; give feedback to the user, if not silent
      invoke DoMsg, p_ret, 0   

      ; free resources
      invoke GetProcessHeap
      mov h_hp, eax
      invoke HeapFree, h_hp, 0, p_source
      invoke HeapFree, h_hp, 0, p_dest
      invoke HeapFree, h_hp, 0, p_key
      invoke HeapFree, h_hp, 0, p_keyval
      invoke HeapFree, h_hp, 0, p_data
      
      RETURN p_ret
Main endp



;############ CheckCmd ###############
CheckCmd Proc
      LOCAL n_err   :DWORD      ; error level
      LOCAL n_ret   :DWORD      ; retval of GetCL
      LOCAL n_len   :DWORD      ; len of the command string
      LOCAL s_part[128] :BYTE    ; command line buffer      
      LOCAL c_arg   :DWORD
      LOCAL c_strg  :DWORD   
      LOCAL b_akt   :BYTE

      mov n_err, 0
      mov c_arg, 1
      mov c_strg, 1     
      lea ecx, s_part
     
      .REPEAT
          ; GetCL's return values are: 1=success, 2=noarg, 3=quotmark error, 4=empty quotmark                                        
          invoke GetCL, c_arg, ADDR s_part           
          mov n_ret, eax
          invoke lstrlen, ADDR s_part
          mov n_len, eax     
          .IF n_ret==1  
                  .IF n_len==2    
                        ; process the flag sign
                        mov al, s_part[1]
                        .IF c_strg > 1
                            ; error: flag arguments should precede path arguments 
                            mov n_err, 8
                        .ELSEIF al==107 ; -k
                            or k_flags, RHVKRYPT_OPT_KEYVALUE
                        .ELSEIF al==102 ; -f
                            or k_flags, RHVKRYPT_OPT_KEYFILE
                        .ELSEIF al==115 ; -s
                            or k_flags, RHVKRYPT_OPT_SILENT
                        .ELSEIF al==99  ; -c
                            or k_flags, RHVKRYPT_OPT_COPY
                        .ELSEIF al==109 ; -m
                            or k_flags, RHVKRYPT_OPT_MASMLIB
                        .ELSE
                            ; unknown-flag error:
                            mov n_err, 9
                        .ENDIF  
                  .ELSE     
                        inc n_len
                        .IF c_strg==1
                            REQUIRE n_len, p_source                            
                            .IF !p_source
	                           RETURN 4
	                       .ENDIF
                            invoke lstrcpy, p_source, ADDR s_part
                        .ELSEIF c_strg==2 && (k_flags & RHVKRYPT_OPT_COPY)
                            ; destination file as second argument expected
                            REQUIRE n_len, p_dest                            
                            .IF !p_dest
	                           RETURN 4
	                      .ENDIF
                            invoke lstrcpy, p_dest, ADDR s_part
                        .ELSEIF c_strg==2 || (c_strg==3 && (k_flags & RHVKRYPT_OPT_COPY))
                            ; keydata expected
                            REQUIRE n_len, p_key                            
                            .IF !p_key
	                           RETURN 4
	                       .ENDIF
                            invoke lstrcpy, p_key, ADDR s_part
                        .ELSE
                            ; too much arguments error
                            mov n_err, 12
                        .ENDIF 
                        inc c_strg 
                  .ENDIF                            
          .ELSEIF n_ret==2
                  .IF c_arg == 1
                        ; no arguments, show standard commandline-expected error
                        mov n_err, 1
                  .ELSEIF c_strg == 1
                        ; filename-expected error
                        mov n_err, 11
                  .ELSE
                        mov n_err, 99
                        ; args retrieved ok, exit                        
                  .ENDIF
          .ELSEIF n_ret==3
                  ; error: no matching quotation marks found
                  mov n_err, 10
          .ELSEIF n_ret==4
                  .IF c_arg==1
                        ; standard commandline-expected error                             
                        mov n_err, 1
                  .ELSE
                        ; empty-string error
                        mov n_err, 13              
                  .ENDIF
          .ENDIF          
           inc c_arg           
      .UNTIL n_err

      ; check if destination is provided
      .IF !p_dest && (k_flags & RHVKRYPT_OPT_COPY)
            RETURN 16
      .ENDIF

      ; if k+f flags combined, suppose f flag
      .IF (k_flags & RHVKRYPT_OPT_KEYVALUE) && (k_flags & RHVKRYPT_OPT_KEYFILE)             
            sub k_flags, RHVKRYPT_OPT_KEYVALUE
      .ENDIF
      
      ; check if key is provided
      .IF !p_key && (k_flags & RHVKRYPT_OPT_KEYVALUE)             
            RETURN 17
      .ENDIF
      .IF !p_key && (k_flags & RHVKRYPT_OPT_KEYFILE)             
            RETURN 17
      .ENDIF
           
      ; ignore replace flag if destination file specified
      .IF p_dest && (k_flags & RHVKRYPT_OPT_COPY)
            xor k_flags, RHVKRYPT_OPT_COPY
      .ENDIF

      ; if no destination file is specified, set source to dest
      .IF !p_dest 
            push p_source
            pop p_dest
      .ENDIF
      
      .IF n_err==99
            RETURN 0            
      .ELSE 
            RETURN n_err
      .ENDIF
CheckCmd endp


;####################### LoadFile ##########################
LoadFile Proc file:DWORD
      LOCAL	n_ret :DWORD, n_read :DWORD
      LOCAL f_high :DWORD       
      LOCAL f_size :DWORD
      LOCAL h_file :DWORD
      LOCAL p_mem  :DWORD

      mov n_ret, 0
      mov f_size, 0

      
      
	invoke CreateFile, file, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0
	mov h_file, eax
	.IF eax==INVALID_HANDLE_VALUE
	    RETURN 2
	.ENDIF

      ; if overwrite is intended, check if the source file is writable
      .IF !(k_flags & RHVKRYPT_OPT_COPY)
          invoke CloseHandle, h_file
          invoke CreateFile, file, GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
          .IF eax==INVALID_HANDLE_VALUE
	        RETURN 19
	    .ENDIF
          invoke CloseHandle, h_file
          invoke CreateFile, file, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0
      .ENDIF
      
	invoke GetFileSize, h_file, ADDR f_high     
	mov f_size, eax
	.IF f_high
	    mov n_ret, 7
	    jmp LINEClose
	.ENDIF
      .IF !f_size
	    mov n_ret, 14
	    jmp LINEClose
	.ENDIF
      
      REQUIRE f_size, p_mem
      .IF !p_mem
	    mov n_ret, 4
	    jmp LINEClose
	.ENDIF
         
	invoke ReadFile, h_file, p_mem, f_size, ADDR n_read, 0      
      .IF !eax
          mov n_ret, 5
	    jmp LINEClose
      ;.ELSEIF n_read != f_size
	    ;mov n_ret, 5
	    ;jmp LINEClose
	.ENDIF	

LINEClose:
      invoke CloseHandle, h_file
      mov ecx, p_mem
      mov edx, f_size
	RETURN n_ret
LoadFile endp


rhvKrypt Proc data :DWORD, key :DWORD, l_data :DWORD, l_key :DWORD
        push ebx
        push esi
        push edi 
        
        mov esi, data       ; incremental data pointer
	  mov edi, key	    ; incremental key pointer
        mov ecx, l_data     ; decremental data len
        mov edx, l_key      ; decremental key len

              
LINELoop:
        ; get actual key byte as word into bx
        xor bx, bx
        mov bl, [edi]           

        ; get actual data byte into al
	  mov al, [esi]
        ; swap bytes
	  not al
        ; add actual key byte, this may overflow our bytes size, so use words
        add ax, bx
        ; write the crypted value % 256 back        
        mov [esi], al
        ; check if we at the end of key...
        inc edi
        dec edx
        jnz LINEKey
        ; in this case lets start a new loop
        mov edi, key	    
        mov edx, l_key      
LINEKey:
        ; check if we are at the end of our data...
        inc esi
        dec ecx           
        jnz LINELoop
        
        pop edi
        pop esi 
        pop ebx

      RETURN 0     
rhvKrypt endp

;####################### SaveFile ##########################
SaveFile proc file:DWORD, pdata :DWORD, fsize :DWORD
      LOCAL	b_ret :DWORD
      LOCAL n_count :DWORD
      LOCAL h_file :DWORD

	invoke CreateFile, file, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	mov h_file, eax
	.IF h_file == INVALID_HANDLE_VALUE
	    RETURN 3
	.ENDIF
      
	invoke WriteFile, h_file, pdata, fsize , ADDR n_count, 0
	mov b_ret, eax
      invoke CloseHandle, h_file
      mov eax, n_count
      .IF (!b_ret) 
          invoke DeleteFile, file
	    RETURN 6
      .ELSEIF eax!=fsize     
          invoke DeleteFile, file
          RETURN 15	    
	.ENDIF

	RETURN 0
SaveFile endp



;####################### DoMsg #############################
DoMsg Proc msg :DWORD, value :DWORD
      LOCAL AktMsg :DWORD
      LOCAL Time1 :DWORD, Time2 :DWORD
      LOCAL tx_tmp[255] :BYTE

      .IF k_flags & RHVKRYPT_OPT_SILENT
            ret
      .ENDIF

      push esi
      mov esi, 0
      .IF msg ==0            
            mov ecx, TIME_2
            mov edx, TIME_3
            mov eax, TIME_4
            sub ecx, TIME_1
            sub edx, TIME_2
            sub eax, TIME_3
            add ecx, eax
            invoke wsprintf, ADDR tx_tmp, ADDR ERR_SUCCESS, ecx, edx
            lea esi, tx_tmp                                    
      .ELSEIF msg ==1
            lea esi, ERR_CMD_MISSING
      .ELSEIF msg==2
            lea esi, ERR_FILE_MISSING
      .ELSEIF msg==3
            lea esi, ERR_DEST_CREATE
      .ELSEIF msg==4
            lea esi, ERR_ALLOC
      .ELSEIF msg==5
            lea esi, ERR_FILE_READ
      .ELSEIF msg==6
            lea esi, ERR_DEST_WRITE
      .ELSEIF msg==7                        
            lea esi, ERR_FILE_SIZE
      .ELSEIF msg==8
            lea esi, ERR_CMD_ORDER
      .ELSEIF msg==9
            lea esi, ERR_CMD_FLAG
      .ELSEIF msg==10
            lea esi, ERR_CMD_QUOT
      .ELSEIF msg==11
            lea esi, ERR_CMD_SOURCE
      .ELSEIF msg==12
            lea esi, ERR_CMD_ARGS
      .ELSEIF msg==13
            lea esi, ERR_CMD_EMPTY   
      .ELSEIF msg==14
            lea esi, ERR_FILE_EMPTY   
      .ELSEIF msg==15
            lea esi, ERR_DEST_FULL   
      .ELSEIF msg==16
            lea esi, ERR_CMD_DEST                                               
      .ELSEIF msg==17
            lea esi, ERR_CMD_KEY
      .ELSEIF msg==18
            lea esi, ERR_KEY_MISSING
      .ELSEIF msg==19
            lea esi, ERR_FILE_WRITABLE
      .ENDIF 
       
      .IF esi               
            invoke MessageBox, HWND_DESKTOP, esi, ADDR APP_TITLE, MB_OK
      .ENDIF
      
      pop esi
      ret
DoMsg endp


end start